#ifndef _ExtractDLG_CPP
#define _ExtractDLG_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <ShlObj.H>
#include <Stdio.H>
#include <ShlOBJ.H>
#include <Stdlib.H>

#include "../Resources/Resource.H"

#include "../Headers/NSWFL.H"
#include "../Headers/Package.H"
#include "../Headers/Entry.H"
#include "../Headers/CommonDialog.H"

#include "../Dialogs/MainDlg.H"
#include "../Dialogs/PackingDlg.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//---------------------(Variable Declarations)
HWND ExtractDialog_hWnd = NULL;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK ExtractDialog(HWND xHandle, UINT xMessage, WPARAM wParam, LPARAM lParam)
{
    //--------------------------------------------------------------------------

    static HMENU SystemMenu = NULL;

    static HWND SelectedRadio_hWnd = NULL;
    static HWND AllFilesRadio_hWnd = NULL;
    static HWND OverwriteCB_hWnd = NULL;
    static HWND SkipOlderFilesCB_hWnd = NULL;
    static HWND UseFolderNamesCB_hWnd = NULL;
    static HWND ExtractToLocation_hWnd = NULL;
    static HWND BrowseTree_hWnd = NULL;

    //--------------------------------------------------------------------------

    if(xMessage == WM_INITDIALOG) // Received A Initilize Dialog Message
    {
        ExtractDialog_hWnd = xHandle;

        SystemMenu = GetSystemMenu(xHandle, FALSE);
        AppendMenu(SystemMenu, MF_SEPARATOR, 0, 0);
        AppendMenu(SystemMenu, MF_STRING, 1000, "About");

        SendMessage(xHandle, (UINT)WM_SETTEXT, (WPARAM)0, (LPARAM)gsTitleCaption);
        SendMessage(xHandle, WM_SETICON, TRUE, (LPARAM) LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN)) );

        SelectedRadio_hWnd     = GetDlgItem(xHandle, IDC_SELECTEDRADIO);
        AllFilesRadio_hWnd     = GetDlgItem(xHandle, IDC_ALLRADIO);
        OverwriteCB_hWnd       = GetDlgItem(xHandle, IDC_OVERWRITE);
        SkipOlderFilesCB_hWnd  = GetDlgItem(xHandle, IDC_SKIPOLDER);
        UseFolderNamesCB_hWnd  = GetDlgItem(xHandle, IDC_USEFOLDERS);
        ExtractToLocation_hWnd = GetDlgItem(xHandle, IDC_EXTRACTLOCATION);
        BrowseTree_hWnd        = GetDlgItem(xHandle, IDC_BROWSETREE);

        InvalidateRect(BrowseTree_hWnd, NULL, 0);

        if(ListView_GetSelectedCount(FileList_hWnd) > 0)
        {
            CheckDlgButton(xHandle, IDC_SELECTEDRADIO, BST_CHECKED);
            CheckDlgButton(xHandle, IDC_ALLRADIO, BST_UNCHECKED);
            EnableWindow(SelectedRadio_hWnd, TRUE);
        }
        else {
            CheckDlgButton(xHandle, IDC_ALLRADIO, BST_CHECKED);
            CheckDlgButton(xHandle, IDC_SELECTEDRADIO, BST_UNCHECKED);
            EnableWindow(SelectedRadio_hWnd, FALSE);
        }

        if(strlen(gsLastExtractLocation) <= 0)
        {
            char InitialDirectory[MAX_PATH + 1];
            GetCurrentDirectory(MAX_PATH, InitialDirectory);
            Set_Text(ExtractToLocation_hWnd, InitialDirectory);
        }
        else Set_Text(ExtractToLocation_hWnd, gsLastExtractLocation);

        CreateTreeImageList(BrowseTree_hWnd);

        InitAlreadyLoaded();

        PopBrowseTree(BrowseTree_hWnd);

        CenterWindow(xHandle);

        return TRUE; // Return TRUE to set the keyboard focus, Otherwise return FALSE
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_NOTIFY)
    {
        NMHDR *lpNMH = (LPNMHDR) lParam;

        if(lpNMH->code == TVN_ITEMEXPANDING || lpNMH->code == TVN_SELCHANGED)
        {
            HTREEITEM hItem = NULL;
            HTREEITEM hParent = NULL;

            char FullSelectedPath[MAX_PATH + 1];
            char Itemtext[MAX_PATH + 1];
            char SelectedPath[MAX_PATH + 1];
            char Parent[MAX_PATH + 1];

            int RPos = 0;
            int WPos = MAX_PATH;

            TVITEMEX tvItemEx;

            memset(&tvItemEx, 0, sizeof(tvItemEx));
            memset(Itemtext, 0, sizeof(Itemtext));

            if(lpNMH->code == TVN_ITEMEXPANDING)
            {
                LPNMTREEVIEW pnmtv = (LPNMTREEVIEW) lParam;
                hItem = pnmtv->itemNew.hItem;
                TreeView_SelectItem(BrowseTree_hWnd, hItem);
            }
            else{
                hItem = TreeView_GetSelection(BrowseTree_hWnd);
            }

            tvItemEx.hItem          = hItem;
            tvItemEx.mask           = TVIF_TEXT;
            tvItemEx.pszText        = Itemtext;
            tvItemEx.cchTextMax     = MAX_PATH;
            TreeView_GetItem(BrowseTree_hWnd, &tvItemEx);

            if(strcmpi(Itemtext, "MyComputer") == 0)
            {
                EnableWindow(GetDlgItem(xHandle, IDC_EXTRACT), FALSE);
                return TRUE;
            }

            hParent = hItem;

            bool Append = false;

            while((hParent = TreeView_GetParent(BrowseTree_hWnd, hParent)))
            {
                tvItemEx.hItem          = hParent;
                tvItemEx.mask           = TVIF_TEXT;
                tvItemEx.pszText        = Parent;
                tvItemEx.cchTextMax     = MAX_PATH;
                TreeView_GetItem(BrowseTree_hWnd, &tvItemEx);

                if(strcmpi(Parent, "MyComputer") == 0)
                {
                    break;
                }

                if(strcmpi(Parent, "desktop") == 0)
                {
                    Append = true;
                }
            }

            if(strcmpi(Itemtext, "Desktop") == 0)
            {
                if(GetDesktopFolderPath(FullSelectedPath))
                {
                    Set_Text(ExtractToLocation_hWnd, FullSelectedPath);
                    EnableWindow(GetDlgItem(xHandle, IDC_EXTRACT), TRUE);
                }
                return TRUE;
            }

            RPos = strlen(Itemtext) - 1;
            while(RPos != -1)
            {
                if(Itemtext[RPos] == '\0') break;
                SelectedPath[WPos] = Itemtext[RPos];
                WPos--;
                RPos--;
            }

            hParent = hItem;

            while( (hParent = TreeView_GetParent(BrowseTree_hWnd, hParent)))
            {
                tvItemEx.hItem          = hParent;
                tvItemEx.mask           = TVIF_TEXT;
                tvItemEx.pszText        = Itemtext;
                tvItemEx.cchTextMax     = MAX_PATH;
                TreeView_GetItem(BrowseTree_hWnd, &tvItemEx);

                if(strcmpi(Itemtext, "Desktop") == 0 || strcmpi(Itemtext, "MyComputer") == 0)
                {
                    break;
                }

                SelectedPath[WPos--] = '\\';

                RPos = strlen(Itemtext) -1;
                while(RPos != -1)
                {
                    if(Itemtext[RPos] == '\0') break;
                    SelectedPath[WPos] = Itemtext[RPos];
                    WPos--;
                    RPos--;
                }
            }

            RPos = WPos+1;
            WPos = 0;
            while(RPos != MAX_PATH+1)
            {
                if(SelectedPath[RPos] == '\0') break;

                FullSelectedPath[WPos] = SelectedPath[RPos];
                WPos++;
                RPos++;
            }

            FullSelectedPath[WPos] = '\0';

            if(Append)
            {
                if(GetDesktopFolderPath(SelectedPath))
                {
                    if(SelectedPath[strlen(SelectedPath) - 1] != '\\')
                        strcat(SelectedPath, "\\");

                    strcat(SelectedPath, FullSelectedPath);
                    Set_Text(ExtractToLocation_hWnd, SelectedPath);
                    EnableWindow(GetDlgItem(xHandle, IDC_EXTRACT), TRUE);
                    strcpy(FullSelectedPath, SelectedPath);
                }
            }
            else{
                Set_Text(ExtractToLocation_hWnd, FullSelectedPath);
            }

            IndexDirectoryForSubItem(BrowseTree_hWnd, hItem, FullSelectedPath, false);

            //---------------------------------------------------------------------------

            HTREEITEM hSibling = NULL;

            strcpy(SelectedPath, FullSelectedPath);

            if((hSibling = TreeView_GetChild(BrowseTree_hWnd, hItem)) != NULL)
            {
                tvItemEx.hItem          = hSibling;
                tvItemEx.mask           = TVIF_TEXT;
                tvItemEx.pszText        = Itemtext;
                tvItemEx.cchTextMax     = MAX_PATH;
                TreeView_GetItem(BrowseTree_hWnd, &tvItemEx);

                strcat(FullSelectedPath, "\\");
                strcat(FullSelectedPath, Itemtext);

                IndexDirectoryForSubItem(BrowseTree_hWnd, hSibling, FullSelectedPath, false);

                while((hSibling = TreeView_GetNextSibling(BrowseTree_hWnd, hSibling)) != NULL)
                {
                    tvItemEx.hItem          = hSibling;
                    tvItemEx.mask           = TVIF_TEXT;
                    tvItemEx.pszText        = Itemtext;
                    tvItemEx.cchTextMax     = MAX_PATH;
                    TreeView_GetItem(BrowseTree_hWnd, &tvItemEx);

                    strcpy(FullSelectedPath, SelectedPath);
                    strcat(FullSelectedPath, "\\");
                    strcat(FullSelectedPath, Itemtext);

                    IndexDirectoryForSubItem(BrowseTree_hWnd, hSibling, FullSelectedPath, false);
                }
            }

            EnableWindow(GetDlgItem(xHandle, IDC_EXTRACT), TRUE);
            return TRUE;
        }
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_COMMAND)
    {
        if(wParam == IDC_EXTRACT)
        {
            int Length = Get_TextEx(ExtractToLocation_hWnd, gsExtractLocation, 255);
            if(Length <= 0 || Length > 255)
            {
                MessageBox(ExtractDialog_hWnd, "You must specifiy a location to extract the files to.", gsTitleCaption, 0);
                return TRUE;
            }

            if(gsExtractLocation[strlen(gsExtractLocation) - 1] != '\\')
            {
                strcat(gsExtractLocation, "\\");
            }

            if(IsDlgButtonChecked(xHandle, IDC_SELECTEDRADIO))
            {
                gdwCurrentJobType = JOB_TYPE_EXTRACTSEL;
            }
            else {
                gdwCurrentJobType = JOB_TYPE_EXTRACTALL;
            }

            FreeAlreadyLoaded();
            EndDialog(xHandle, 1);

            return TRUE;
        }

        if(wParam == IDC_CANCEL)
        {
            FreeAlreadyLoaded();
            EndDialog(xHandle, 0);
            return TRUE;
        }

        return FALSE;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_PAINT)
    {
        HDC ThisHDC;
        PAINTSTRUCT ThisPS;

        ThisHDC = BeginPaint(xHandle, &ThisPS);

        // Any painting should be done here

        EndPaint(xHandle, &ThisPS);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_SYSCOMMAND) // Received A System Menu Message
    {
        if(LOWORD(wParam) == 1000) //- About (SysMenu Command)
        {
            _AboutDialogInfo ADI;
    
            ADI.DisplayIcon  = LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN));
            ADI.TitleCaption = gsTitleCaption;
            ADI.FileVersion  = gsFileVersion;
            ADI.BuildDate    = __DATE__;
            ADI.BuildTime    = __TIME__;
            ADI.CopyRight    = gsAppCopyRight;
            ADI.OwnerHandle  = xHandle;

            NetLogo(&ADI);
            return TRUE;
        }

        return FALSE;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_CLOSE)  // Received Close Message
    {
        FreeAlreadyLoaded();
        EndDialog(xHandle, 0);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

